Index: cpukit/sapi/src/debug.c
===================================================================
--- cpukit/sapi/src/debug.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
+++ cpukit/sapi/src/debug.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -0,0 +1,62 @@
+/*
+ *  Debug Manager
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/debug.h>
+
+/*PAGE
+ *
+ *  _Debug_Manager_initialization
+ */
+ 
+void _Debug_Manager_initialization( void )
+{
+  rtems_debug_disable( RTEMS_DEBUG_ALL_MASK );
+}
+ 
+/*PAGE
+ *
+ *  rtems_debug_enable
+ */
+ 
+void rtems_debug_enable (
+  rtems_debug_control  to_be_enabled
+)
+{
+  _Debug_Level |= to_be_enabled;
+}
+ 
+/*PAGE
+ *
+ *  rtems_debug_disable
+ */
+ 
+void rtems_debug_disable (
+  rtems_debug_control  to_be_disabled
+)
+{
+  _Debug_Level &= ~to_be_disabled;
+}
+
+/*PAGE
+ *
+ *  _Debug_Is_enabled
+ */
+
+boolean _Debug_Is_enabled(
+  rtems_debug_control  level
+)
+{
+  return (_Debug_Level & level);
+}
Index: cpukit/sapi/src/exinit.c
===================================================================
--- cpukit/sapi/src/exinit.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/sapi/src/exinit.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,152 +1,245 @@
-/* SPDX-License-Identifier: BSD-2-Clause */
-
-/**
- * @file
- *
- * @ingroup RTEMSImplClassic
- *
- * @brief This source file contains the definition of ::_Copyright_Notice,
- *   ::_Objects_Information_table, the flexible per-CPU data linker set limits,
- *   the system initialization linker set limits and the implementation of
- *   rtems_initialize_executive().
- */
-
 /*
- *  COPYRIGHT (c) 1989-2014.
+ *  Initialization Manager
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
  *  On-Line Applications Research Corporation (OAR).
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
-
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+/*
+ *  INIT is defined so all of the data will be included in this
+ *  file.
+ */
+
+#define INIT
+
+#include <rtems/system.h>
 #include <rtems/config.h>
-#include <rtems/extensionimpl.h>
+#include <rtems/copyrt.h>
+#include <rtems/clock.h>
+#include <rtems/tasks.h>
+#include <rtems/debug.h>
+#include <rtems/dpmem.h>
+#include <rtems/event.h>
+#include <rtems/extension.h>
+#include <rtems/fatal.h>
+#include <rtems/heap.h>
 #include <rtems/init.h>
-#include <rtems/sysinit.h>
-#include <rtems/score/sysstate.h>
-
-#include <rtems/score/copyrt.h>
-#include <rtems/score/heap.h>
-#include <rtems/score/interr.h>
-#include <rtems/score/isr.h>
-#include <rtems/score/priority.h>
-#include <rtems/score/schedulerimpl.h>
-#include <rtems/score/smpimpl.h>
-#include <rtems/score/timecounter.h>
-#include <rtems/score/threadimpl.h>
-#include <rtems/score/todimpl.h>
-
-RTEMS_SECTION(".rtemsroset.copyright") const char _Copyright_Notice[] =
-  "Copyright (C) 1989, 2021 RTEMS Project and contributors";
-
-static Objects_Information *
-_Internal_Objects[ OBJECTS_INTERNAL_CLASSES_LAST + 1 ];
-
-static Objects_Information *_RTEMS_Objects[ OBJECTS_RTEMS_CLASSES_LAST + 1 ];
-
-static Objects_Information *_POSIX_Objects[ OBJECTS_POSIX_CLASSES_LAST + 1 ];
-
-Objects_Information ** const
-_Objects_Information_table[ OBJECTS_APIS_LAST + 1 ] = {
-  NULL,
-  &_Internal_Objects[ 0 ],
-  &_RTEMS_Objects[ 0 ],
-  &_POSIX_Objects[ 0 ]
+#include <rtems/intthrd.h>
+#include <rtems/isr.h>
+#include <rtems/intr.h>
+#include <rtems/io.h>
+#include <rtems/message.h>
+#include <rtems/mp.h>
+#include <rtems/mpci.h>
+#include <rtems/part.h>
+#include <rtems/priority.h>
+#include <rtems/ratemon.h>
+#include <rtems/region.h>
+#include <rtems/sem.h>
+#include <rtems/signal.h>
+#include <rtems/sysstate.h>
+#include <rtems/thread.h>
+#include <rtems/timer.h>
+#include <rtems/tod.h>
+#include <rtems/userext.h>
+#include <rtems/watchdog.h>
+#include <rtems/wkspace.h>
+
+#include <rtems/sptables.h>
+
+/*PAGE
+ *
+ *  rtems_initialize_executive
+ *
+ *  This directive initializes all the kernels data structures
+ *  to the states necessary for the kernel to begin execution.  All
+ *  include files that contain global variable definitions should be
+ *  included in this file.  The system threads and initialization threads
+ *  are created and started by this routine.  This routine then
+ *  initiates multithreading.
+ *
+ *  Input parameters:
+ *    configuration_table - pointer to the user's configuration table
+ *    cpu_table           - pointer to the user's CPU configuration table
+ *
+ *  Output parameters:  NONE
+ */
+
+struct months {
+  unsigned32 months[2][13];
 };
 
-static void rtems_initialize_data_structures(void)
-{
+void rtems_initialize_executive(
+  rtems_configuration_table *configuration_table,
+  rtems_cpu_table           *cpu_table
+)
+{
+  rtems_interrupt_level bsp_level;
+
+  bsp_level = rtems_initialize_executive_early(configuration_table, cpu_table);
+  rtems_initialize_executive_late( bsp_level );
+}
+
+rtems_interrupt_level rtems_initialize_executive_early(
+  rtems_configuration_table *configuration_table,
+  rtems_cpu_table           *cpu_table
+)
+{
+  rtems_interrupt_level        bsp_level;
+  rtems_multiprocessing_table *multiprocessing_table;
+
   /*
    *  Dispatching and interrupts are disabled until the end of the
    *  initialization sequence.  This prevents an inadvertent context
    *  switch before the executive is initialized.
-   *
-   *  WARNING: Interrupts should have been disabled by the BSP and
-   *           are disabled by boot_card().
    */
 
+  _ISR_Disable( bsp_level );
+
+  _System_state_Set( SYSTEM_STATE_BEFORE_INITIALIZATION );
+
+  _CPU_Initialize( cpu_table, _Thread_Dispatch );
+
+  multiprocessing_table = configuration_table->User_multiprocessing_table;
+  if ( multiprocessing_table == NULL )
+    multiprocessing_table =
+      (void *) &_Configuration_Default_multiprocessing_table;
+
+  _Configuration_Handler_initialization(
+    configuration_table,
+    multiprocessing_table,
+    multiprocessing_table->User_mpci_table
+  );
+
+  _Attributes_Handler_initialization();
+
+  _Thread_Dispatch_initialization();
+
+  _User_extensions_Handler_initialization(
+    configuration_table->User_extension_table
+  );
+
+  _Workspace_Handler_initialization(
+     (void *)configuration_table->work_space_start,
+     configuration_table->work_space_size
+  );
+
+  _ISR_Handler_initialization();
+
+  _Objects_Handler_initialization(
+    multiprocessing_table->node,
+    multiprocessing_table->maximum_global_objects
+  );
+
+  _Priority_Handler_initialization();
+
+  _Watchdog_Handler_initialization();
+
+  _TOD_Handler_initialization( configuration_table->microseconds_per_tick );
+
+  _Thread_Handler_initialization(
+    configuration_table->maximum_tasks,
+    configuration_table->ticks_per_timeslice,
+    multiprocessing_table->maximum_proxies
+  );
+
+  _MPCI_Handler_initialization();
+
+/* MANAGERS */
+
+  _Interrupt_Manager_initialization();
+
+  _Multiprocessing_Manager_initialization();
+
+  _Timer_Manager_initialization( configuration_table->maximum_timers );
+
+  _Extension_Manager_initialization( configuration_table->maximum_extensions );
+
+  _IO_Manager_initialization(
+    configuration_table->Device_driver_table,
+    configuration_table->number_of_device_drivers
+  );
+
+  _Event_Manager_initialization();
+
+  _Message_queue_Manager_initialization(
+    configuration_table->maximum_message_queues,
+    configuration_table->maximum_messages
+  );
+
+  _Semaphore_Manager_initialization(
+    configuration_table->maximum_semaphores
+  );
+
+  _Partition_Manager_initialization(
+    configuration_table->maximum_partitions
+  );
+
+  _Region_Manager_initialization( configuration_table->maximum_regions );
+
+  _Dual_ported_memory_Manager_initialization(
+    configuration_table->maximum_ports
+  );
+
+  _Rate_monotonic_Manager_initialization(
+    configuration_table->maximum_periods
+  );
+
+  _Internal_threads_Initialization();
+
+  if ( cpu_table->pretasking_hook )
+    (*cpu_table->pretasking_hook)();
+
+  _System_state_Set( SYSTEM_STATE_BEFORE_MULTITASKING );
+
+  return bsp_level;
+}
+
+void rtems_initialize_executive_late(
+  rtems_interrupt_level bsp_level
+)
+{
+
+  _System_state_Set( SYSTEM_STATE_BEGIN_MULTITASKING );
+
+  _Thread_Start_multitasking(
+    _Internal_threads_System_initialization_thread,
+    _Internal_threads_Idle_thread
+  );
+
   /*
-   * Initialize any target architecture specific support as early as possible
+   *  Restore the interrupt level to what the BSP had.  Technically,
+   *  this is unnecessary since the BSP should have all interrupts
+   *  disabled when rtems_initialize_executive is invoked.  But this keeps
+   *  the ISR Disable/Enable calls paired.
    */
-  _CPU_Initialize();
-
-  _Thread_Dispatch_initialization();
-
-  _ISR_Handler_initialization();
-
-  _Thread_Handler_initialization();
-
-  _Scheduler_Handler_initialization();
-
-  _SMP_Handler_initialize();
-}
-
-RTEMS_LINKER_ROSET( _Sysinit, rtems_sysinit_item );
-
-RTEMS_SYSINIT_ITEM(
-  rtems_initialize_data_structures,
-  RTEMS_SYSINIT_DATA_STRUCTURES,
-  RTEMS_SYSINIT_ORDER_MIDDLE
-);
-
-/*
- *  No threads should be created before this point!!!
- *  _Thread_Executing and _Thread_Heir are not set.
- *
- *  At this point all API extensions are in place.  After the call to
- *  _Thread_Create_idle() _Thread_Executing and _Thread_Heir will be set.
- *
- *  Scheduling can properly occur afterwards as long as we avoid dispatching.
- */
-RTEMS_SYSINIT_ITEM(
-  _Thread_Create_idle,
-  RTEMS_SYSINIT_IDLE_THREADS,
-  RTEMS_SYSINIT_ORDER_MIDDLE
-);
-
-void rtems_initialize_executive(void)
-{
-  const rtems_sysinit_item *item;
-
-  /* Invoke the registered system initialization handlers */
-  RTEMS_LINKER_SET_FOREACH( _Sysinit, item ) {
-    ( *item->handler )();
-  }
-
-  _System_state_Set( SYSTEM_STATE_UP );
-
-  _SMP_Request_start_multitasking();
-
-  _Thread_Start_multitasking();
-
-  /*******************************************************************
-   *******************************************************************
-   *******************************************************************
-   ******                 APPLICATION RUNS HERE                 ******
-   ******              THE FUNCTION NEVER RETURNS               ******
-   *******************************************************************
-   *******************************************************************
-   *******************************************************************/
-}
+
+  _ISR_Enable( bsp_level );
+}
+
+/*PAGE
+ *
+ *  rtems_shutdown_executive
+ *
+ *  This kernel routine shutdowns the executive.  It halts multitasking
+ *  and returns control to the application execution "thread" which
+ *  initialially invoked the rtems_initialize_executive directive.
+ *
+ *  Input parameters:   NONE
+ *
+ *  Output parameters:  NONE
+ */
+
+void rtems_shutdown_executive(
+   unsigned32 result
+)
+{
+  _Thread_Stop_multitasking();
+}
Index: cpukit/sapi/src/extension.c
===================================================================
--- cpukit/sapi/src/extension.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/sapi/src/extension.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,48 +1,156 @@
-/**
- * @file
+/*
+ *  Extension Manager
  *
- * @ingroup RTEMSImplClassicUserExt
  *
- * @brief This source file contains a definition of the
- *   ::_Extension_Information with zero objects.
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
  */
 
-/*
- * SPDX-License-Identifier: BSD-2-Clause
+#include <rtems/system.h>
+#include <rtems/object.h>
+#include <rtems/thread.h>
+#include <rtems/extension.h>
+
+/*PAGE
  *
- * Copyright (C) 2018 embedded brains GmbH & Co. KG
+ *  _Extension_Manager_initialization
  *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
+ *  This routine initializes all extension manager related data structures.
  *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
+ *  Input parameters:
+ *    maximum_extensions - number of extensions to initialize
+ *
+ *  Output parameters:  NONE
  */
 
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
+void _Extension_Manager_initialization(
+  unsigned32 maximum_extensions
+)
+{
+  _Objects_Initialize_information(
+     &_Extension_Information,
+     FALSE,
+     maximum_extensions,
+     sizeof( Extension_Control )
+  );
+}
 
-#include <rtems/extensiondata.h>
+/*PAGE
+ *
+ *  rtems_extension_create
+ *
+ *  This directive creates a extension and performs some initialization.
+ *
+ *  Input parameters:
+ *    name            - extension name
+ *    extension_table - pointer to extension set information
+ *    id              - pointer to extension id
+ *
+ *  Output parameters:
+ *    id                - extension id
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
 
-OBJECTS_INFORMATION_DEFINE_ZERO(
-  _Extension,
-  OBJECTS_CLASSIC_API,
-  OBJECTS_RTEMS_EXTENSIONS,
-  OBJECTS_NO_STRING_NAME
-);
+rtems_status_code rtems_extension_create(
+  Objects_Name                   name,
+  rtems_extensions_table *extension_table,
+  Objects_Id                    *id
+)
+{
+  Extension_Control *the_extension;
+
+  if ( !_Objects_Is_name_valid( name ) )
+    return ( RTEMS_INVALID_NAME );
+
+  _Thread_Disable_dispatch();         /* to prevent deletion */
+
+  the_extension = _Extension_Allocate();
+
+  if ( !the_extension ) {
+    _Thread_Enable_dispatch();
+    return( RTEMS_TOO_MANY );
+  }
+
+  _User_extensions_Add_set( &the_extension->Extension, extension_table );
+
+  _Objects_Open( &_Extension_Information, &the_extension->Object, name );
+
+  *id = the_extension->Object.id;
+  _Thread_Enable_dispatch();
+  return( RTEMS_SUCCESSFUL );
+}
+
+/*PAGE
+ *
+ *  rtems_extension_ident
+ *
+ *  This directive returns the system ID associated with
+ *  the extension name.
+ *
+ *  Input parameters:
+ *    name - user defined message queue name
+ *    id   - pointer to extension id
+ *
+ *  Output parameters:
+ *    *id               - message queue id
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_extension_ident(
+  Objects_Name  name,
+  Objects_Id   *id
+)
+{
+  return _Objects_Name_to_id(
+    &_Extension_Information,
+    name,
+    RTEMS_SEARCH_LOCAL_NODE,
+    id
+  );
+}
+
+/*PAGE
+ *
+ *  rtems_extension_delete
+ *
+ *  This directive allows a thread to delete a extension.
+ *
+ *  Input parameters:
+ *    id - extension id
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code - if unsuccessful
+ */
+
+rtems_status_code rtems_extension_delete(
+  Objects_Id id
+)
+{
+  Extension_Control   *the_extension;
+  Objects_Locations    location;
+
+  the_extension = _Extension_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+    case OBJECTS_REMOTE:            /* should never return this */
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_LOCAL:
+      _User_extensions_Remove_set( &the_extension->Extension );
+      _Objects_Close( &_Extension_Information, &the_extension->Object );
+      _Extension_Free( the_extension );
+      _Thread_Enable_dispatch();
+      return( RTEMS_SUCCESSFUL );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
Index: cpukit/sapi/src/fatal.c
===================================================================
--- cpukit/sapi/src/fatal.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/sapi/src/fatal.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,53 +1,53 @@
-/* SPDX-License-Identifier: BSD-2-Clause */
-
-/**
- * @file
- *
- * @ingroup RTEMSImplClassic
- *
- * @brief This source file contains the implementation of
- *   rtems_fatal_error_occurred().
- */
-
 /*
  *  Fatal Error Manager
  *
- *  COPYRIGHT (c) 1989-2009.
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
  *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
  *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
  *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
+ *  $Id$
  */
 
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
+#include <rtems/system.h>
+#include <rtems/config.h>
+#include <rtems/fatal.h>
+#include <rtems/sysstate.h>
+#include <rtems/userext.h>
 
-#include <rtems/fatal.h>
-#include <rtems/score/interr.h>
+/*PAGE
+ *
+ *  rtems_fatal_error_occurred
+ *
+ *  This directive will invoke the fatal error handler supplied by the user
+ *  followed by the the default one provided by the executive.  The default
+ *  error handler assumes no hardware is present to help inform the user
+ *  of the problem.  Halt stores the error code in a known register,
+ *  disables interrupts, and halts the CPU.  If the CPU does not have a
+ *  halt instruction, it will loop to itself.
+ *
+ *  Input parameters:
+ *    the_error - fatal error status code
+ *
+ *  Output parameters:
+ *    the_error       - on stack
+ *    status register - on stack
+ *
+ *  NOTE: The the_error is not necessarily a directive status code.
+ */
 
-void rtems_fatal_error_occurred(
-  uint32_t   the_error
+void volatile rtems_fatal_error_occurred(
+  unsigned32 the_error
 )
 {
-  _Terminate( INTERNAL_ERROR_RTEMS_API, the_error );
+
+  _User_extensions_Fatal( the_error );
+
+  _System_state_Set( SYSTEM_STATE_FAILED );
+
+  _CPU_Fatal_halt( the_error );
 
 /* will not return from this routine */
